
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'package:get/get_state_manager/src/rx_flutter/rx_obx_widget.dart';
import 'package:get_storage/get_storage.dart';
import '../controller/enx_controller.dart';
import '../models/setting_model.dart';
import '../models/setting_model_list.dart';
class SettingScreen extends StatelessWidget{
  EnxController enxController;
   SettingScreen(this.enxController,{Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return   Obx(() => Scaffold(
      body: ListView.builder(
        itemCount: enxController.settingList.length,
        itemBuilder: (BuildContext context, int index) =>
            expandableList(enxController.settingList[index]),
      ),
    ));
  }
  Widget expandableList(SettingModelList settingList) {
    return  ExpansionTile(
      initiallyExpanded: true,
      title: Text(
        settingList.name,
        style: const TextStyle(fontSize: 17,fontWeight: FontWeight.w500),
      ),
      children: settingList.settingList.map((e) => SwitchListTile( //switch at left side of label
          value: e.isStatus,
          controlAffinity: ListTileControlAffinity.trailing,
          onChanged: (bool value){
            e.isStatus=!e.isStatus;

            enxController.settingList.refresh();
            String jsonString = jsonEncode(enxController.settingList);
            GetStorage().write("setting", jsonString);
            //obj.isAudioOnly.value=!obj.isAudioOnly.value;
            //obj.isAudioOnly.refresh();
          },
          title:  Text("${e.name}",style: const TextStyle(fontSize: 15,color: Colors.black,fontWeight: FontWeight.w400),)
      )).toList()

    );

}}
