import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

class BaseAlertDialog extends StatelessWidget {
  //When creating please recheck 'context' if there is an error!

  Color _color = Colors.white;

  String title;
  String content;
  String yes;
  String no;
  Function yesOnPressed;
  Function noOnPressed;

  BaseAlertDialog(
      {Key? key,
      required this.title,
      required this.content,
      required this.yesOnPressed,
      required this.noOnPressed,
      this.yes = 'Yes',
      this.no = "No"})
      : super(key: key) {}

  @override
  Widget build(BuildContext context) {
    return AlertDialog(
      title: Text(title),
      content: Text(content),
      backgroundColor: _color,
      shape:
          RoundedRectangleBorder(borderRadius: new BorderRadius.circular(15)),
      actions: <Widget>[
        ElevatedButton(
          child: Text(
            yes,
            style: TextStyle(fontSize: 16.sp, color: Colors.red),
          ),
          onPressed: () {
            this.yesOnPressed();
          },
        ),
        ElevatedButton(
          child: Text(
            no,
            style: TextStyle(fontSize: 16.sp, color: Colors.black),
          ),
          onPressed: () {
            this.noOnPressed();
          },
        ),
      ],
    );
  }
}
