

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

import '../buttons/custom_button.dart';
import '../controller/enx_controller.dart';
import '../utilities/color.dart';

Widget lobbyUi(context, EnxController obj, message){
  return  Container(
color: Colors.grey,
    width: MediaQuery.of(context).size.width,
    height: MediaQuery.of(context).size.height,
    child: Column(

      children: [
         Align(
           alignment: Alignment.topCenter,
           child: Padding(
             padding:  EdgeInsets.all(MediaQuery.of(context).size.width/10),
             child: Image.asset("assets/image/profile_place_holder.png", package: 'enx_uikit_flutter',semanticLabel:obj.getClientName,),
           ),
         ),
         Padding(
          padding:  EdgeInsets.all(MediaQuery.of(context).size.width/25),
          child: Text("Welcome ${obj.getClientName}",style: TextStyle(fontSize: MediaQuery.of(context).size.width/20.sp,fontWeight: FontWeight.w600,),),
        ),
         Center(
           child: Padding(
            padding:   EdgeInsets.all(MediaQuery.of(context).size.width/25),
            child: Text("$message",style: TextStyle(fontSize: MediaQuery.of(context).size.width/24.sp,fontWeight: FontWeight.w500,),),
        ),
         ),
        const Spacer(),
        Padding(
          padding:  EdgeInsets.only(bottom: 20.0),
          child: Align(
            alignment: Alignment.bottomCenter,
            child: CustomMaterialButton(
              onPressed: () => {obj.endCall('')},
              child: const Icon(Icons.call_end_rounded, color: Colors.white, size: 20),
              shape: const CircleBorder(),
              elevation: 2.0,
              fillColor: CustomColors.themeColor,
            ),
          ),
        )

      ],),
  );
}